angular.module('mnJsonTables', ['mnJsonTablesCell']).directive('mnJsonTables', function () {

  return {
    restrict: 'A',
    scope: {
      mnJsonTables: '='
    },
    templateUrl: '/components/directives/mn_json_tables/mn_json_tables.html',
    controller: function ($scope) {
      $scope.trackByTopLevelObjectAndIndex = function ($index, value) {
        //console.log("trackObjectAndIndex");
        return $index + '-' + JSON.stringify(value, function (k, v) {
          return _.isPlainObject(v) && !!k ? undefined : v;
        });
      };
      $scope.$watch("mnJsonTables", function (mnJsonTables) {
        //console.log("processing data for table");
        var parsedJson;
        if (_.isString(mnJsonTables)) {
          try {
            parsedJson = JSON.parse(mnJsonTables);
          } catch (e) {}
        } else {
          parsedJson = mnJsonTables;
        }

        if (_.isPlainObject(parsedJson)) {
          $scope.parsedJson = [parsedJson];
          $scope.itemsKeysToObject = parsedJson;
          return;
        }

        if (!_.isCollection(parsedJson)) {
          return;
        }

        var itemsKeysToObject = {};
        _.forEach(parsedJson, function (item, index) {
          _.forEach(item, function (value, key) {
            itemsKeysToObject[key] = true;
          });
        });

        $scope.parsedJson = parsedJson;
        $scope.itemsKeysToObject = itemsKeysToObject;
      }, true);
    }
  };
});